<?php

class Funcoes 
{
	
	// Completa caracteres
	function strPad($text, $Qtd) {
		
		return str_pad($text, $Qtd, "0", STR_PAD_LEFT);
		
	}
	
	// Busca cep
	function searchCep($cep) {
		
		ini_set("allow_url_fopen",1);
		ini_set("allow_url_include",1);
		
		// file_get_contents - Lê todo o conteúdo de um arquivo para uma string
	   	$resultado = @file_get_contents('http://republicavirtual.com.br/web_cep.php?cep='.urlencode($cep).'&formato=query_string');  
	   
	   	if(!$resultado){
		   
			$resultado = "&resultado=0&resultado_txt=erro+ao+buscar+cep"; 
		   
	   	}  
	   	// Converte a string em variáveis
	   	parse_str($resultado, $retorno);  
	   
	   	return $retorno; 
	   
	}  
	
	function _url($u) {
		
		if ($u == "twa") {
			return "forms/frmCfgAlterarSenha.php";
		} else if ($u == "rps") {
			return "forms/frmCfgRecuperarSenha.php";
		} else if ( ($u == "ybm") || ($u == "") ) {
			return "includes/model/m.Inicio.php";
		}
	}
	
	// Entrada data Y-m-d
	function expDataBrasil($DateTime) {
		
		if($DateTime) {
		
			$data = explode("-", $DateTime);
			
			$DataTime = $data[2]."/".$data[1]."/".$data[0];
			// Saída d/m/Y
			return $DataTime;
		}
		
	}
	
	// Entrada data d/m/Y
	function expDataInternational($DateTime) {
		
		if($DateTime) {
		
			$data = explode("/", $DateTime);
			
			$DataTime = $data[2]."-".$data[1]."-".$data[0];
			// Saída Y-m-d
			return $DataTime;
		}
	}
	
	// Entrada data Y-m-d h:i:s
	function expDateTime($DateTime) {
		
		if($DateTime) {
		
			$data = explode(" ", $DateTime);
			
			$data2 = explode("-", $data[0]);
			
			$DataTime = $data2[2]."/".$data2[1]."/".$data2[0]." ".$data[1];
			// Saída d/m/Y h:i:s
			return $DataTime;
		}
	}
	
	// Entrada data d/m/Y H:i:s
	function expDateTimeInt($DateTime) {
		
		if($DateTime) {
		
			$data = explode(" ", $DateTime);
			
			$data2 = explode("/", $data[0]);
			
			$DataTime = $data2[2]."-".$data2[1]."-".$data2[0]." ".$data[1];
			// Saída Y-m-d H:i:s
			return $DataTime;
		}
	}
	
	// Entrada data Y-m-d h:i:s
	function expDate($DateTime) {
		
		if($DateTime) {
		
			$data = explode(" ", $DateTime);
			
			$data2 = explode("-", $data[0]);
			
			$DataTime = $data2[2]."/".$data2[1]."/".$data2[0];
			// Saída d/m/Y
			return $DataTime;
		}
	}
	
	// Select data
	function Dia($inicio, $fim, $select) {
		
		for ($x = $inicio; $x <= $fim; $x++) {
		
			if ($select == $x)
			{
				?>
				<option selected="selected" value="<?php echo str_pad($x, 2, "0", STR_PAD_LEFT); ?>"><?php echo str_pad($x, 2, "0", STR_PAD_LEFT); ?></option>
				<?php
			}
			else
			{
				?>
				<option value="<?php echo str_pad($x, 2, "0", STR_PAD_LEFT); ?>"><?php echo str_pad($x, 2, "0", STR_PAD_LEFT); ?></option>
				<?php
			}
		}
	}
	
	// Select data ano
	function Ano($inicio, $fim, $select) {
		
		for ($x = $inicio; $x <= $fim; $x++) {
		
			if ($select == $x)
			{
				?>
				<option selected="selected" value="<?php echo $x; ?>"><?php echo $x; ?></option>
				<?php
			}
			else
			{
				?>
				<option value="<?php echo $x; ?>"><?php echo $x; ?></option>
				<?php
			}
		}
	}
	
	function generateRandomString($length = 10, $letters = '1qw2ert3yui4opa5sd6fghj7klz8xc9vbnm0') 
	{ 
		$s = ''; 
		$lettersLength = strlen($letters)-1; 
		
		for($i = 0 ; $i < $length ; $i++) 
		{ 
		$s .= $letters[rand(0,$lettersLength)]; 
		} 
		
		return $s; 
	}
	
	// Formata Cpf/Cnpj
	function formataCpfCnpj($campo, $formatado = true){
		//retira formato
		$codigoLimpo = ereg_replace("[' '-./ t]",'',$campo);
		// pega o tamanho da string menos os digitos verificadores
		$tamanho = (strlen($codigoLimpo) -2);
		//verifica se o tamanho do código informado é válido
		if ($tamanho != 9 && $tamanho != 12){
			return false;
		}
	
		if ($formatado){
			// seleciona a máscara para cpf ou cnpj
			$mascara = ($tamanho == 9) ? '###.###.###-##' : '##.###.###/####-##'; 
	
			$indice = -1;
			for ($i=0; $i < strlen($mascara); $i++) {
				if ($mascara[$i]=='#') $mascara[$i] = $codigoLimpo[++$indice];
			}
			//retorna o campo formatado
			$retorno = $mascara;
	
		}else{
			//se não quer formatado, retorna o campo limpo
			$retorno = $codigoLimpo;
		}
	
		return $retorno;
	}	
	
	// Função que valida o CPF
	function valCpf($cpf)
	{	
		// Verifiva se o número digitado contém todos os digitos
		$cpf = str_pad(ereg_replace('[^0-9]', '', $cpf), 11, '0', STR_PAD_LEFT);
		
		// Verifica se nenhuma das sequências abaixo foi digitada, caso seja, retorna falso
		if (strlen($cpf) != 11 || $cpf == '00000000000' || $cpf == '11111111111' || $cpf == '22222222222' || $cpf == '33333333333' || $cpf == '44444444444' || $cpf == '55555555555' || $cpf == '66666666666' || $cpf == '77777777777' || $cpf == '88888888888' || $cpf == '99999999999')
		{
			return false;
		}
		else
		{   // Calcula os números para verificar se o CPF é verdadeiro
			for ($t = 9; $t < 11; $t++) {
				for ($d = 0, $c = 0; $c < $t; $c++) {
					$d += $cpf{$c} * (($t + 1) - $c);
				}
	
				$d = ((10 * $d) % 11) % 10;
	
				if ($cpf{$c} != $d) {
					return false;
				}
			}
	
			return true;
		}
	}
	
	/**
	 * Diferença entre duas data, devolve o total de dias
	 */
	function _dateDiferenca($Data)
	{
		$Data = explode("-", $Data);
		
		//calculo timestam das duas datas
		$timestamp1 = mktime(0, 0, 0, $Data[1], $Data[2], $Data[0]);
		$timestamp2 = mktime(4, 12, 0,date("m"), date("d"), date("Y"));
		
		//diminuo a uma data a outra
		$segundos_diferenca = $timestamp1 - $timestamp2;
		// echo $segundos_diferenca;
		
		// converto segundos em dias
		$dias_diferenca = $segundos_diferenca / (60 * 60 * 24);
		
		// obtenho o valor absoluto dos dias (tiro o possível sinal negativo)
		$dias_diferenca = abs($dias_diferenca);
		
		// tiro os decimais aos dias de diferenca
		return floor($dias_diferenca);
		
	}
	
	function sendMail($nome, $email, $subject, $body, $msg)
	{
		
		// INSTÂNCIANDO O OBJETO
		$this->objBd = new BdMySql;
		// EXECUTA A QUERY
		$Campo = $this->objBd->LoadFromId("SELECT * FROM tblCfgServidorEmail LIMIT 1");
		
		/**
		 Notificação do sistema
		 */
		
		// Diz que o cdigo est na pasta raiz /phpmailer/
		ini_set('include_path','.:/phpmailer/'); 
		// Classe PhpMailer
		require_once($_SERVER['DOCUMENT_ROOT'] . "/includes/view/phpmailer/class.phpmailer.php");
		// Criando a instância
		$mail = new PHPMailer();
		// Definindo a linguagem
		$mail->SetLanguage("br", $_SERVER['DOCUMENT_ROOT'] . "/includes/view/phpmailer/language/");
		// Envio via SMTP
		$mail->IsSMTP(); 
		// Seu servidor smtp
		$mail->Host = $Campo["ccSrvHostSmtp"];
		// Smtp autenticado
		$mail->SMTPAuth = $Campo["ccSrvAutenticacao"];
		// Usuário deste servidor SMTP
		$mail->Username = $Campo["ccSrvUsuario"];
		// Senha do servidor de e-mail
		$mail->Password = $Campo["ccSrvSenha"];
		// Remetente
		$mail->From = $Campo["ccSrvEmailRemetente"];
		// Nome do remetente
		$mail->FromName = $Campo["ccSrvNomeRemetente"];
		// Destinatário e-mail e nome
		$mail->AddAddress($email, $nome);
		// Set word wrap
		$mail->WordWrap = 50;
		// Send as HTML
		$mail->IsHTML($Campo["ccSrvHtml"]);
		// Assunto
		$mail->Subject = $subject;
		// Corpo da mensagem
		$mail->Body = utf8_decode($body);
		// Envio
		if(!$mail->Send())
		{
			$msg = "Erro: " . $mail->ErrorInfo;
			//$msg = "<strong>ATENÇÃO!</strong> &nbsp; Algumas funções estão desabilitadas, não consegui notificar o suporte. Por favor entre em contato com a equipe técnica do sistema.";
		}
		else
		{
			$msg = $msg;
		}
		return $msg;
	}
	
	/**
	 * Removendo SqlInjection
	 */
	function remCodMalicioso($tx) {
		$comSeguranca = addslashes($tx);
		$tx = htmlspecialchars($tx);
		$tx = str_replace("SELECT","",$tx);
		$tx = str_replace("FROM","",$tx);
		$tx = str_replace("WHERE","",$tx);
		$tx = str_replace("INSERT","",$tx);
		$tx = str_replace("UPDATE","",$tx);
		$tx = str_replace("DELETE","",$tx);
		$tx = str_replace("DROP","",$tx);
		$tx = str_replace("DATABASE","",$tx);
		
		return $tx;
	}
	
	function fopenTxt($filename, $conteudo)
	{
		// Primeiro vamos ter certeza de que o arquivo existe e pode ser alterado
		if (is_writable($filename)) {
		
		 // Em nosso exemplo, nós vamos abrir o arquivo $filename
		 // em modo de adição. O ponteiro do arquivo estará no final
		 // do arquivo, e é pra lá que $conteudo irá quando o 
		 // escrevermos com fwrite().
			if (!$handle = fopen($filename, 'a')) {
				 $turn = "Não foi possível abrir o arquivo ($filename)";
				 exit;
			}
		
			// Escreve $conteudo no nosso arquivo aberto.
			if (fwrite($handle, "\n".$conteudo) === FALSE) {
				$turn = "Não foi possível escrever no arquivo ($filename)";
				exit;
			}
		
			$turn = "Sucesso: Escrito ($conteudo) no arquivo ($filename)";
		
			fclose($handle);
		
		} else {
			
			if (!$handle = fopen($filename, 'w+')) {
				 $turn = "Não foi possível abrir o arquivo ($filename)";
				 exit;
			}
		
			// Escreve $conteudo no nosso arquivo aberto.
			if (fwrite($handle, $conteudo) === FALSE) {
				$turn = "Não foi possível escrever no arquivo ($filename)";
				exit;
			}
		
			$turn = "Sucesso: Escrito ($conteudo) no arquivo ($filename)";
		
			fclose($handle);
		}
		return $turn;
	}
	
}

?>